chiark / gitweb /
do not use git-show-ref as it is hopeless; just do it ourselves
[dgit.git] / dgit
diff --git a/dgit b/dgit
index a2e148898c2b7d22ce532ffeeab0c3f4eb4f31ef..5fc937898d77ca14c1c031eecd933adbd81606b4 100755 (executable)
--- a/dgit
+++ b/dgit
@@ -26,32 +26,46 @@ use Dpkg::Control::Hash;
 use File::Path;
 use POSIX;
 
-open DEBUG, ">&STDERR" or die $!;
-
-our $mirror = 'http://mirror.relativity.greenend.org.uk/mirror/debian-ftp/';
 our $suite = 'sid';
 our $package;
 
 our $sign = 1;
-our $nopush = 0;
+our $dryrun = 0;
+our $changesfile;
+our $new_package = 0;
+our $existing_package = 'dpkg';
 
-our $aliothname = 'iwj@git.debian.org';
-our $aliothpath = '/git/dgit-test';
-our $alioth_git = "git+ssh://$aliothname/$aliothpath";
-our $alioth_sshtestbodge = [$aliothname,$aliothpath];
+our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
 
-our (@dget_opts) = qw(-u);
-our (@git_tag_opts);
-our (@gpg_opts);
+our (@git) = qw(git);
+our (@dget) = qw(dget);
+our (@dput) = qw(dput);
+our (@debsign) = qw(debsign);
+our $keyid;
 
-our $remotename = 'dgit';
-our $ourdscfield = 'Vcs-git-master';
+our $debug = 0;
+open DEBUG, ">/dev/null" or die $!;
 
-sub uploadbranch () { return "dgit/$suite"; }
-sub lref ($) { return "refs/heads/$_[0]"; }
-sub rref ($) { return "refs/remotes/$remotename/$_[0]"; }
+our %opts_opt_map = ('dget' => \@dget,
+                    'dput' => \@dput,
+                    'debsign' => \@debsign);
+
+our $remotename = 'dgit';
+our $ourdscfield = 'Vcs-Dgit-Master';
+our $branchprefix = 'dgit';
+
+sub lbranch () { return "$branchprefix/$suite"; }
+my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
+sub lref () { return "refs/heads/".lbranch(); }
+sub lrref () { return "refs/remotes/$remotename/$suite"; }
+sub rrref () { return "refs/$branchprefix/$suite"; }
 sub debiantag ($) { return "debian/$_[0]"; }
 
+sub fetchspec () {
+    local $suite = '*';
+    return  "+".rrref().":".lrref();
+}
+
 our $ua;
 
 sub url_get {
@@ -59,7 +73,7 @@ sub url_get {
        $ua = LWP::UserAgent->new();
        $ua->env_proxy;
     }
-    print DEBUG "fetching @_...\n";
+    print "downloading @_...\n";
     my $r = $ua->get(@_) or die $!;
     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
     return $r->decoded_content();
@@ -67,22 +81,120 @@ sub url_get {
 
 our ($dscdata,$dscurl,$dsc);
 
+sub printcmd {
+    my $fh = shift @_;
+    my $intro = shift @_;
+    print $fh $intro or die $!;
+    local $_;
+    foreach my $a (@_) {
+       $_ = $a;
+       if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
+           print $fh " '$_'" or die $!;
+       } else {
+           print $fh " $_" or die $!;
+       }
+    }
+    print $fh "\n" or die $!;
+}
+
 sub runcmd {
+    printcmd(\*DEBUG,"+",@_) if $debug>0;
     $!=0; $?=0;
     die "@_ $! $?" if system @_;
 }
 
-sub cmdoutput {
+sub cmdoutput_errok {
+    die Dumper(\@_)." ?" if grep { !defined } @_;
+    printcmd(\*DEBUG,"|",@_) if $debug>0;
     open P, "-|", @_ or die $!;
     my $d;
     $!=0; $?=0;
     { local $/ = undef; $d = <P>; }
     die if P->error;
-    close P or die "@_ $? $!";
+    if (!close P) { print DEBUG "=>!$?\n" if $debug>0; return undef; }
     chomp $d;
+    $d =~ m/^.*/;
+    print DEBUG "=> \`$&'",(length $' ? '...' : ''),"\n" if $debug>0; #';
+    return $d;
+}
+
+sub cmdoutput {
+    my $d = cmdoutput_errok @_;
+    defined $d or die "@_ $? $!";
     return $d;
 }
 
+sub dryrun_report {
+    printcmd(\*STDOUT,"#",@_);
+}
+
+sub runcmd_ordryrun {
+    if (!$dryrun) {
+       runcmd @_;
+    } else {
+       dryrun_report @_;
+    }
+}
+
+our %defcfg = ('dgit.default.distro' => 'debian',
+              'dgit.default.username' => '',
+              'dgit.default.archive-query-default-component' => 'main',
+              'dgit.default.ssh' => 'ssh',
+              'dgit-distro.debian.git-host' => 'git.debian.org',
+              'dgit-distro.debian.git-proto' => 'git+ssh://',
+              'dgit-distro.debian.git-path' => '/git/dgit-repos',
+              'dgit-distro.debian.git-check' => 'ssh-cmd',
+              'dgit-distro.debian.git-create' => 'ssh-cmd',
+              'dgit-distro.debian.mirror' => 'http://ftp.debian.org/debian/');
+
+sub cfg {
+    foreach my $c (@_) {
+       my $v;
+       {
+           local ($debug) = $debug-1;
+           $v = cmdoutput_errok(@git, qw(config --), $c);
+       };
+       if ($?==0) {
+           return $v;
+       } elsif ($?!=256) {
+           die "$c $?";
+       }
+       my $dv = $defcfg{$c};
+       return $dv if defined $dv;
+    }
+    return undef;
+}
+
+sub access_distro () {
+    return cfg("dgit-suite.$suite.distro",
+              "dgit.default.distro");
+}
+
+sub access_cfg ($) {
+    my ($key) = @_;
+    my $distro = access_distro();
+    my $value = cfg("dgit-distro.$distro.$key",
+                   "dgit.default.$key");
+    return $value;
+}
+
+sub access_gituserhost () {
+    my $user = access_cfg('git-user');
+    my $host = access_cfg('git-host');
+    return defined($user) && length($user) ? "$user\@$host" : $host;
+}
+
+sub access_giturl () {
+    my $url = access_cfg('git-url');
+    if (!defined $url) {
+       $url =
+           access_cfg('git-proto').
+           access_gituserhost().
+           access_cfg('git-path');
+    }
+    return "$url/$package.git";
+}             
+
 sub parsecontrol {
     my $c = Dpkg::Control::Hash->new();
     $c->load(@_) or return undef;
@@ -98,44 +210,90 @@ sub parsechangelog {
     return $c;
 }
 
-sub get_archive_dsc () {
-    my $rmad = cmdoutput qw(rmadison -asource),"-s$suite",$package;
-    $rmad =~ m/^ \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* \|
+our %rmad;
+
+sub archive_query () {
+    my $query = access_cfg('archive-query');
+    $query ||= "madison:".access_distro();
+    $query =~ s/^(\w+):// or die "$query ?";
+    my $proto = $1;
+    my $url = $'; #';
+    die unless $proto eq 'madison';
+    $rmad{$package} ||= cmdoutput
+       qw(rmadison -asource),"-s$suite","-u$url",$package;
+    my $rmad = $rmad{$package};
+    if (!length $rmad) {
+       return ();
+    }
+    $rmad =~ m{^ \s*( [^ \t|]+ )\s* \|
                  \s*( [^ \t|]+ )\s* \|
-                 \s*( [^ \t|]+ )\s* /x or die "$rmad $?";
+                 \s*( [^ \t|/]+ )(?:/([^ \t|/]+))? \s* \|
+                 \s*( [^ \t|]+ )\s* }x or die "$rmad $?";
     $1 eq $package or die "$rmad $package ?";
     my $vsn = $2;
-    $3 eq $suite or die "$rmad $suite ?";
-    $4 eq 'source' or die "$rmad ?";
-    # fixme it does not show us the component ?
+    if ($suite ne $3) {
+       # madison canonicalises for us
+       print "canonical suite name for $suite is $3\n";
+       $suite = $3;
+    }
+    my $component;
+    if (defined $4) {
+       $component = $4;
+    } else {
+       $component = access_cfg('archive-query-default-component');
+    }
+    $5 eq 'source' or die "$rmad ?";
     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
-    $dscurl = "$mirror/pool/main/$prefix/$package/${package}_$vsn.dsc";
-#print DEBUG Dumper($pdodata, $&, $dscurl);
+    my $subpath = "/pool/$component/$prefix/$package/${package}_$vsn.dsc";
+    return ($vsn,$subpath);
+}
+
+sub canonicalise_suite () {
+    archive_query() or die;
+}
+
+sub get_archive_dsc () {
+    my ($vsn,$subpath) = archive_query();
+    if (!defined $vsn) { $dsc=undef; return undef; }
+    $dscurl = access_cfg('mirror').$subpath;
     $dscdata = url_get($dscurl);
     my $dscfh = new IO::File \$dscdata, '<' or die $!;
-#print DEBUG Dumper($dscdata, $dscfh);
+    print DEBUG Dumper($dscdata) if $debug>1;
     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
-#print DEBUG Dumper($dsc);
+    print DEBUG Dumper($dsc) if $debug>1;
     my $fmt = $dsc->{Format};
-    die "unsupported format $fmt, sorry\n" unless $fmt eq '1.0';
+    die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
 }
 
 sub check_for_git () {
     # returns 0 or 1
-    my $cmd= 
-       "ssh $alioth_sshtestbodge->[0] '".
-       " set -e; cd /git/dgit-test;".
-       " if test -d $package.git; then echo 1; else echo 0; fi".
-       "'";
-    #print DEBUG "$cmd\n";
-    open P, "$cmd |" or die $!;
-    $!=0; $?=0;
-    my $r = <P>; close P;
-#print STDERR ">$r<\n";
-    die "$r $! $?" unless $r =~ m/^[01]$/;
-    return $r+0;
+    my $how = access_cfg('git-check');
+    if ($how eq 'ssh-cmd') {
+       my $r= cmdoutput
+           (access_cfg('ssh'),access_gituserhost(),
+            " set -e; cd ".access_cfg('git-path').";".
+            " if test -d $package.git; then echo 1; else echo 0; fi");
+       print DEBUG "got \`$r'\n";
+       die "$r $! $?" unless $r =~ m/^[01]$/;
+       return $r+0;
+    } else {
+       die "unknown git-check $how ?";
+    }
+}
+
+sub create_remote_git_repo () {
+    my $how = access_cfg('git-create');
+    if ($how eq 'ssh-cmd') {
+       runcmd_ordryrun
+           (access_cfg('ssh'),access_gituserhost(),
+            "set -e; cd ".access_cfg('git-path').";".
+            " mkdir -p $package.git;".
+            " cd $package.git;".
+            " if ! test -d objects; then git init --bare; fi");
+    } else {
+       die "unknown git-create $how ?";
+    }
 }
 
 our ($dsc_hash,$upload_hash);
@@ -160,9 +318,9 @@ sub mktree_in_ud_from_only_subdir () {
     runcmd qw(git init -q);
     rmtree('.git/objects');
     symlink '../../../../objects','.git/objects' or die $!;
-    runcmd qw(git add -Af);
-    my $tree = cmdoutput qw(git write-tree);
-    chomp $tree; $tree =~ m/^\w+$/ or die "$tree ?";
+    runcmd @git, qw(add -Af);
+    my $tree = cmdoutput @git, qw(write-tree);
+    $tree =~ m/^\w+$/ or die "$tree ?";
     return ($tree,$dir);
 }
 
@@ -175,7 +333,7 @@ sub dsc_files () {
 
 sub is_orig_file ($) {
     local ($_) = @_;
-    m/\.orig\.tar\.\w+$/;
+    m/\.orig(?:-\w+)?\.tar\.\w+$/;
 }
 
 sub generate_commit_from_dsc () {
@@ -189,9 +347,9 @@ sub generate_commit_from_dsc () {
            or $!==&ENOENT
            or die "$f $!";
     }
-    runcmd qw(dget), @dget_opts, qw(--), $dscurl;
+    runcmd @dget, qw(--), $dscurl;
     foreach my $f (grep { is_orig_file($_) } @files) {
-       link $f, "../../../$f"
+       link $f, "../../../../$f"
            or $!==&EEXIST
            or die "$f $!";
     }
@@ -205,27 +363,27 @@ sub generate_commit_from_dsc () {
     $authline =~ m/^[^<>]+ \<\S+\> \d+ [-+]\d+$/ or die $authline;
     open C, ">../commit.tmp" or die $!;
     print C "tree $tree\n" or die $!;
-    print C "parent $upload_hash\n" or die $! if defined $upload_hash;
+    print C "parent $upload_hash\n" or die $! if $upload_hash;
     print C <<END or die $!;
 author $authline
 committer $authline
 
 $clogp->{Changes}
 
-# imported by dgit from the archive
+# imported from the archive
 END
     close C or die $!;
+    my $commithash = cmdoutput @git, qw(hash-object -w -t commit ../commit.tmp);
     print "synthesised git commit from .dsc $clogp->{Version}\n";
-    my $commithash = cmdoutput qw(git hash-object -w -t commit ../commit.tmp);
     chdir '../../../..' or die $!;
-    cmdoutput qw(git update-ref -m),"dgit synthesise $clogp->{Version}",
+    cmdoutput @git, qw(update-ref -m),"dgit synthesise $clogp->{Version}",
               'DGIT_ARCHIVE', $commithash;
-    cmdoutput qw(git log -n2), $commithash;
+    cmdoutput @git, qw(log -n2), $commithash;
     # ... gives git a chance to complain if our commit is malformed
     my $outputhash = $commithash;
-    if (defined $upload_hash) {
+    if ($upload_hash) {
        chdir "$ud/$dir" or die $!;
-       runcmd qw(git reset --hard), $upload_hash;
+       runcmd @git, qw(reset --hard), $upload_hash;
        runcmd qw(sh -ec), 'dpkg-parsechangelog >>../changelogold.tmp';
        my $oldclogp = Dpkg::Control::Hash->new();
        $oldclogp->parse('../changelogold.tmp','previous changelog') or die;
@@ -263,184 +421,309 @@ sub ensure_we_have_orig () {
        $origurl .= "/$f";
        die "$f ?" unless $f =~ m/^${package}_/;
        die "$f ?" if $f =~ m#/#;
-       runcmd qw(sh -ec),'cd ..; exec dget -- "$1"','x',$origurl;
+       runcmd_ordryrun qw(sh -ec),'cd ..; exec "$@"','x',
+           @dget,'--',$origurl;
     }
 }
 
 sub rev_parse ($) {
-    return cmdoutput qw(git rev-parse --), "$_[0]~0";
+    return cmdoutput @git, qw(rev-parse), "$_[0]~0";
 }
 
 sub is_fast_fwd ($$) {
     my ($ancestor,$child) = @_;
-    my $mb = cmdoutput qw(git merge-base), $dsc_hash, $upload_hash;
+    my $mb = cmdoutput @git, qw(merge-base), $ancestor, $child;
     return rev_parse($mb) eq rev_parse($ancestor);
 }
 
+sub git_fetch_us () {
+    die "cannot dry run with fetch" if $dryrun;
+    runcmd @git, qw(fetch),access_giturl(),fetchspec();
+}
+
 sub fetch_from_archive () {
-    # ensures that rref(uploadbranch()) is what is actually in the archive,
+    # ensures that lrref() is what is actually in the archive,
     #  one way or another
-    my $upload_ref = rref(uploadbranch());
-    $!=0; $upload_hash = `git show-ref --heads $upload_ref`;
-    die $! if $!;
-    die $? unless ($?==0 && chomp $upload_hash) 
-       or ($?==256 && !length $upload_hash);
+    get_archive_dsc() or return 0;
+    $dsc_hash = $dsc->{$ourdscfield};
+    if (defined $dsc_hash) {
+       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
+       $dsc_hash = $&;
+       print "last upload to archive specified git hash\n";
+    } else {
+       print "last upload to archive has NO git hash\n";
+    }
+
+    my $lrref_fn = ".git/".lrref();
+    if (open H, $lrref_fn) {
+       $upload_hash = <H>;
+       chomp $upload_hash;
+       die "$lrref_fn $upload_hash ?" unless $upload_hash =~ m/^\w+$/;
+    } elsif ($! == &ENOENT) {
+       $upload_hash = '';
+    } else {
+       die "$lrref_fn $!";
+    }
+    print DEBUG "last upload hash $upload_hash\n";
     my $hash;
     if (defined $dsc_hash) {
        die "missing git history even though dsc has hash"
-           unless length $upload_hash;
+           unless $upload_hash;
        $hash = $dsc_hash;
        ensure_we_have_orig();
     } else {
        $hash = generate_commit_from_dsc();
     }
-    if (length $upload_hash) {
+    if ($upload_hash) {
        die "not fast forward on last upload branch!".
            " (archive's version left in DGIT_ARCHIVE)"
            unless is_fast_fwd($dsc_hash, $upload_hash);
     }
     if ($upload_hash ne $hash) {
-       cmdoutput qw(git update-ref -m), 'dgit fetch', $upload_ref, $hash;
+       my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
+       if (!$dryrun) {
+           cmdoutput @upd_cmd;
+       } else {
+           dryrun_report @upd_cmd;
+       }
     }
+    return 1;
 }
 
-sub clone () {
-    get_archive_dsc();
-    $dsc_hash = $dsc->{$ourdscfield};
-    if (defined $dsc_hash) {
-       $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
-       $dsc_hash = $&;
-       print "last upload to archive specified git hash\n";
-    } else {
-       print "last upload to archive has NO git hash\n";
-    }
-    my $dstdir = "$package";
+sub clone ($) {
+    my ($dstdir) = @_;
+    die "dry run makes no sense with clone" if $dryrun;
+    mkdir $dstdir or die "$dstdir $!";
+    chdir "$dstdir" or die "$dstdir $!";
+    runcmd @git, qw(init -q);
+    runcmd @git, qw(config), "remote.$remotename.fetch", fetchspec();
+    open H, "> .git/HEAD" or die $!;
+    print H "ref: ".lref()."\n" or die $!;
+    close H or die $!;
+    runcmd @git, qw(remote add), 'origin', access_giturl();
     if (check_for_git()) {
-       print "cloning existing git history\n";
-       runcmd qw(git clone --origin),$remotename, qw(-b), $suite, '--',
-           $alioth_git, $dstdir;
-       chdir "$dstdir" or die "$dstdir $!";
-       fetch_from_archive();
-       runcmd qw(git reset --hard), rref(uploadbranch());
+       print "fetching existing git history\n";
+       git_fetch_us();
+       runcmd @git, qw(fetch origin);
     } else {
        print "starting new git history\n";
-       mkdir $dstdir or die "$dstdir $!";
-       chdir "$dstdir" or die "$dstdir $!";
-       runcmd qw(git init -q);
-       open H, "> .git/HEAD" or die $!;
-       print H "ref: ".lref(uploadbranch())."\n" or die $!;
-       close H or die $!;
-       runcmd qw(git remote add), $remotename, $alioth_git;
-       runcmd "git config branch.$suite.remote $remotename";
-       runcmd "git config branch.$suite.merge ".lref(uploadbranch());
-       my $newhash = generate_commit_from_dsc();
-       runcmd qw(git reset --hard), $newhash;
     }
+    fetch_from_archive() or die;
+    runcmd @git, qw(reset --hard), lrref();
     print "ready for work in $dstdir\n";
 }
 
 sub fetch () {
     if (check_for_git()) {
-       runcmd qw(git fetch -p),$remotename,
-           '+refs/heads/*:refs/remotes/origin/*';
+       git_fetch_us();
     }
-    fetch_from_archive();
+    fetch_from_archive() or die;
 }
 
 sub pull () {
     fetch();
-    runcmd qw(git merge -m),"Merge from $suite [dgit]",lref(uploadbranch());
+    runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
+        lrref();
 }
 
 sub dopush () {
-    runcmd qw(git diff --quiet HEAD);
+    runcmd @git, qw(diff --quiet HEAD);
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     my $dscfn = "${package}_$clogp->{Version}.dsc";
-    stat $dscfn or die "$dscfn $!";
+    stat "../$dscfn" or die "$dscfn $!";
     $dsc = parsecontrol("../$dscfn");
     prep_ud();
     chdir $ud or die $!;
     print "checking that $dscfn corresponds to HEAD\n";
     runcmd qw(dpkg-source -x --), "../../../../$dscfn";
-    my $tree = mktree_in_ud_from_only_subdir();
+    my ($tree,$dir) = mktree_in_ud_from_only_subdir();
     chdir '../../../..' or die $!;
-    runcmd qw(git diff --exit-code), $tree;
+    runcmd @git, qw(diff --exit-code), $tree;
 #fetch from alioth
 #do fast forward check and maybe fake merge
 #    if (!is_fast_fwd(mainbranch
-#    runcmd qw(git fetch -p ), $alioth_git,
+#    runcmd @git, qw(fetch -p ), "$alioth_git/$package.git",
 #        map { lref($_).":".rref($_) }
 #        (uploadbranch());
     $dsc->{$ourdscfield} = rev_parse('HEAD');
     $dsc->save("../$dscfn.tmp") or die $!;
-    rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
-    if ($sign) {
-       runcmd qw(git tag -s),@git_tag_opts,qw(-m),
-           "Release $dsc->{Version} for $suite [dgit]";
-       unlink "../$dscfn.asc" or $!==&ENOENT or die "$dscfn.asc $!";
-       runcmd qw(gpg --clearsign),@gpg_opts,"../$dscfn";
-       rename "../$dscfn.asc","../$dscfn" or die "$dscfn $!";
+    if (!$dryrun) {
+       rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
+    } else {
+       print "[new .dsc left in $dscfn.tmp]\n";
+    }
+    if (!$changesfile) {
+       my $pat = "../${package}_$clogp->{Version}_*.changes";
+       my @cs = glob $pat;
+        die "$pat ?" unless @cs==1;
+       ($changesfile) = @cs;
     }
-    if (!$nopush) {
-       runcmd qw(git push),$remotename,"HEAD:".lref(uploadbranch());
-       runcmd qw(dput),"../$dscfn";
+    my $tag = debiantag($dsc->{Version});
+    if (!check_for_git()) {
+       create_remote_git_repo();
+    }
+    runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
+    if ($sign) {
+       my @tag_cmd = (@git, qw(tag -s -m),
+                      "Release $dsc->{Version} for $suite [dgit]");
+       push @tag_cmd, qw(-u),$keyid if defined $keyid;
+       push @tag_cmd, $tag;
+       runcmd_ordryrun @tag_cmd;
+       my @debsign_cmd = @debsign;
+       push @debsign_cmd, "-k$keyid" if defined $keyid;
+       push @debsign_cmd, $changesfile;
+       runcmd_ordryrun @debsign_cmd;
     }
+    runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
+    my $host = access_cfg('upload-host');
+    my @hostarg = defined($host) ? ($host,) : ();
+    runcmd_ordryrun @dput, @hostarg, $changesfile;
 }
 
 sub cmd_clone {
+    parseopts();
+    my $dstdir;
+    die if defined $package;
     if (@ARGV==1) {
        ($package) = @ARGV;
-    } elsif (@ARGV==2) {
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
        ($package,$suite) = @ARGV;
+    } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
+       ($package,$dstdir) = @ARGV;
+    } elsif (@ARGV==3) {
+       ($package,$suite,$dstdir) = @ARGV;
     } else {
        die;
     }
-    clone();
+    $dstdir ||= "$package";
+    clone($dstdir);
 }
 
 sub branchsuite () {
-    my $branch = `git-symbolic-ref HEAD`;
-    if ($branch =~ m#^refs/heads/dgit/([^/.]+)$#) {
+    my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
+    if ($branch =~ m#$lbranch_re#o) {
        return $1;
     } else {
        return undef;
     }
 }
 
-sub cmd_fetch {
-    my $clogp = parsechangelog();
-    $package = $clogp->{Source};
+sub fetchpullargs () {
+    if (!defined $package) {
+       my $sourcep = parsecontrol('debian/control');
+       $package = $sourcep->{Source};
+    }
     if (@ARGV==0) {
        $suite = branchsuite();
-       $suite ||= $clogp->{Distribution};
+       if (!$suite) {
+           my $clogp = parsechangelog();
+           $suite = $clogp->{Distribution};
+       }
+       canonicalise_suite();
        print "fetching from suite $suite\n";
     } elsif (@ARGV==1) {
        ($suite) = @ARGV;
+       canonicalise_suite();
     } else {
        die;
     }
+}
+
+sub cmd_fetch {
+    parseopts();
+    fetchpullargs();
     fetch();
 }
 
+sub cmd_pull {
+    parseopts();
+    fetchpullargs();
+    pull();
+}
+
 sub cmd_push {
+    parseopts();
+    die if defined $package;
     my $clogp = parsechangelog();
     $package = $clogp->{Source};
     if (@ARGV==0) {
        $suite = $clogp->{Distribution};
+       if ($new_package) {
+           local ($package) = $existing_package; # this is a hack
+           canonicalise_suite();
+       }
     } else {
        die;
     }
+    if (fetch_from_archive()) {
+       is_fast_fwd(lrref(), 'HEAD') or die;
+    } else {
+       die unless $new_package;
+    }
     dopush();
 }
 
+sub cmd_build {
+    # we pass further options and args to git-buildpackage
+    die if defined $package;
+    my $clogp = parsechangelog();
+    $suite = $clogp->{Distribution};
+    $package = $clogp->{Source};
+    runcmd_ordryrun
+       qw(git-buildpackage -us -uc --git-no-sign-tags),
+       '--git-builder=dpkg-buildpackage -i\.git/ -I.git',
+       "--git-debian-branch=".lbranch(),
+       @ARGV;
+}
+
 sub parseopts () {
-    die if @ARGV && $ARGV[0] =~ m/^\-/;
+    my $om;
+    while (@ARGV) {
+       last unless $ARGV[0] =~ m/^-/;
+       $_ = shift @ARGV;
+       last if m/^--?$/;
+       if (m/^--/) {
+           if (m/^--dry-run$/) {
+               $dryrun=1;
+           } elsif (m/^--no-sign$/) {
+               $sign=0;
+           } elsif (m/^--new$/) {
+               $new_package=1;
+           } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
+               $om->[0] = $2;
+           } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
+               push @$om, $2;
+           } elsif (m/^--existing-package=(.*)/s) {
+               $existing_package = $1;
+           } else {
+               die "$_ ?";
+           }
+       } else {
+           while (m/^-./s) {
+               if (s/^-n/-/) {
+                   $dryrun=1;
+               } elsif (s/^-D/-/) {
+                   open DEBUG, ">&STDERR" or die $!;
+                   $debug++;
+               } elsif (s/^-N/-/) {
+                   $new_package=1;
+               } elsif (s/^-c(.*=.*)//s) {
+                   push @git, '-c', $1;
+               } elsif (s/^-C(.*)//s) {
+                   $changesfile = $1;
+               } elsif (s/^-k(.*)//s) {
+                   $keyid=$1;
+               } else {
+                   die "$_ ?";
+               }
+           }
+       }
+    }
 }
 
 parseopts();
 die unless @ARGV;
 my $cmd = shift @ARGV;
-parseopts();
 
 { no strict qw(refs); &{"cmd_$cmd"}(); }